11.8.6   os16: proc_init(9)

NOME

    proc_init - inizializzazione della gestione complessiva dei processi
    elaborativi

SINTASSI

    <kernel/proc.h>
    extern uint16_t _etext;
    void proc_init (void);

ARGOMENTI

    Argomento                 Descrizione
                              La variabile <_etext> viene fornita dal
                              compilatore e rappresenta l'indirizzo in cui
                              l'area codice si e` conclusa. Il valore di
    extern uint16_t <_etext;> <_etext> si riferisce a un'area codice che inizia
                              dall'indirizzo zero, pertanto questo dato viene
                              usato per conoscere la dimensione dell'area
                              codice del kernel.

DESCRIZIONE

    La funzione <proc_init()> viene usata una volta sola, dalla funzione main
    (9) [11.6], per predisporre la gestione dei processi. Per la precisione
    svolge le operazioni seguenti:

      □ carica la tabella IVT, in modo che le interruzioni software (1C)_16 e
        (80)_16 siano dirette correttamente al codice che deve gestirle;

      □ programma il temporizzatore interno, in modo da produrre una frequenza
        di circa 18,2 Hz;

      □ inizializza la tabella dei processi in modo che tutti gli alloggiamenti
        previsti risultino liberi;

      □ innesta il file system principale, presupponendo che possa trattarsi
        soltanto della prima unita` a dischetti;

      □ inizializza correttamente le voci del processo zero, ovvero quelle del
        kernel, segnando anche come allocata la porzione di memoria utilizzata
        dal kernel e lo spazio iniziale usato dal BIOS (tabella IVT e BDA);

      □ abilita le interruzioni hardware del temporizzatore, della tastiera e
        dell'unita` a dischetti: le altre interruzioni hardware rimangono
        disabilitate.

FILE SORGENTI

    kernel/proc.h [12.9]

    kernel/proc/proc_table.c [12.9.29]

    kernel/proc/proc_init.c [12.9.6]

VEDERE ANCHE

    ivt_load(9) [11.8.2], proc_available(9) [11.8.3], sb_mount(9) [11.3.46].

